"""

Project 1:

Create a Car class with three subclasses

The subclasses should be: Sedan, Convertible and Minivan that
each inherit the Car class.

Create a static variable inside of the Car class that says something
about all cars. Static variables are NOT defined when an object is
created because they are not in the class constructor. Instead they
are just in the class and describe the class in general.

Create at least 4 variables that describe a Car (name, model, mileage)
Create at least 3 Member functions/methods that use the Car's class member
variables.

At least one method should take in parameter(s) that are not in the class
constructor.

Override a method at least once in each subclass and expand on the function
definition in each subclass. Also include at least 1 new method in each subclass

Write some code to test your classes. Create at least 4 objects/instances (one for
each subclass and one for the parent class) to test all of your class code.
"""

class Car:
    vehicle_size = "Small"

    def __init__(self, model, mileage, color, license_plate_number):
        self.model = model
        self.mileage = mileage
        self.color = color
        self.license_plate_number = license_plate_number


    def print_model(self):
        print(self.model + " is the make of this car.")

    def miles_to_km(self):
        print("This " + self.model + " has " + str(self.mileage) + " miles on it which is " + str(self.mileage * 1.6) + " kilometers.")

    def print_license_number(self):
        print("The license number of this " + self.model + " is " + self.license_plate_number)

    def add_mileage(self, more_mileage):
        self.milage += more_mileage


class Sedan(Car):
    def print_model(self):
        super().print_model()
        print("This car is a Sedan.")

    def sedan(self):
        print("This car can hold four people.")

class Convertible(Car):
    def print_model(self):
        super().print_model()
        print("This car is a Convertible.")

    def convertible(self):
        print("This car has a convertible roof.")






class Minivan(Car):
    def print_model(self):
        print(self.model + " is the make of this car.")
        print("This car is a Minivan.")

    def minivan(self):
        print("This car can hold seven people.")


ford_F150 = Car("2021 Ford F-150", 30000, "Silver", "AEY 8567" )
toyota_corolla = Sedan("2021 Toyota Corolla", 50000, "Blue", "DZG 6667" )
ford_mustang = Convertible("2021 Ford Mustang", 70000, "Black", "DFF 5427" )
honda_odyssey = Minivan("2021 Honda Odyssey", 100000, "White", "BCD 8613" )


print(ford_F150.vehicle_size)


ford_F150.print_model()

print("\n")

toyota_corolla.print_model()
ford_mustang.print_model()
honda_odyssey.print_model()

print("\n")

toyota_corolla.sedan()
ford_mustang.convertible()
honda_odyssey.minivan()

print("\n")

print(ford_F150.mileage)
print(toyota_corolla.mileage)
print(ford_mustang.mileage)
print(honda_odyssey.mileage)